
TYPO3.Flow - Bug # 45876

Status: Resolved Priority: Must have
Author: Mattias Nilsson Category: Utility
Created: 2013-02-27 Assigned To: Karsten Dambekalns
Updated: 2013-03-27 Due date:
PHP Version: 5.3
Has patch: No
Complexity:
Affected Flow version: (any)
Subject: Exception in TypeHandling with PHP < 5.3.7
Description

When adding new content in Neos an exception is thrown. Refrencing to the file:
TYPO3.Flow/Classes/TYPO3/Flow/Utility/TypeHandling.php

ExtDirect error: Uncaught exception #1 (ref 2013022708244558d7f1) - Warning: Unknown class passed as parameter in
/Applications/MAMP/htdocs/phoenix.dev/Base/Packages/Framework/TYPO3.Flow/Classes/TYPO3/Flow/Utility/TypeHandling.php line
118

Related issues:
related to TYPO3.Flow - Bug # 44535: Subclasses of SplObjectStorage, ArrayObj... Resolved 2013-01-15

Associated revisions
Revision 57a78d3b - 2013-03-08 08:43 - Mattias Nilsson

[BUGFIX] Exception thrown in TypeHandling

When using isCollectionType() on an unknown class, an exception is
caused by a warning PHP gives about that class being unknown.

The issue has been introduced together with the patch
I007b0faf486680ecfb2fe7c753ef4cabcf6d618c

This adds a check that the element is a known class before using
is_subclass_of() to prevent the exception.

Change-Id: Iae59221cbd72677e6c18ad0a383792a798447253
Fixes: #45876
Releases: master, 2.0, 1.1

Revision 5772372b - 2013-03-14 14:59 - Benno Weinzierl

[BUGFIX] Exception thrown in TypeHandling (follow up)

When using isCollectionType() on an string, a warning is thrown.
The change id Iae59221cbd72677e6c18ad0a383792a798447253 introduced this.

Change-Id: Idb1a18fddae425fe03c4c1102c22133d716a6b65
Resolves: #45876
Releases: master, 2.0, 1.1

2015-08-04 1/8



Revision 988e05c2 - 2013-03-19 17:36 - Mattias Nilsson

[BUGFIX] Exception thrown in TypeHandling

When using isCollectionType() on an unknown class, an exception is
caused by a warning PHP gives about that class being unknown.

The issue has been introduced together with the patch
I007b0faf486680ecfb2fe7c753ef4cabcf6d618c

This adds a check that the element is a known class before using
is_subclass_of() to prevent the exception.

Change-Id: Iae59221cbd72677e6c18ad0a383792a798447253
Fixes: #45876
Releases: master, 2.0, 1.1

Revision 2a8841d3 - 2013-03-19 17:37 - Benno Weinzierl

[BUGFIX] Exception thrown in TypeHandling (follow up)

When using isCollectionType() on an string, a warning is thrown.
The change id Iae59221cbd72677e6c18ad0a383792a798447253 introduced this.

Change-Id: Idb1a18fddae425fe03c4c1102c22133d716a6b65
Resolves: #45876
Releases: master, 2.0, 1.1

Revision d555f69b - 2013-03-27 12:05 - Mattias Nilsson

[BUGFIX] Exception thrown in TypeHandling

When using isCollectionType() on an unknown class, an exception is
caused by a warning PHP gives about that class being unknown.

The issue has been introduced together with the patch
I007b0faf486680ecfb2fe7c753ef4cabcf6d618c

This adds a check that the element is a known class before using
is_subclass_of() to prevent the exception.

Change-Id: Iae59221cbd72677e6c18ad0a383792a798447253
Fixes: #45876
Releases: master, 2.0, 1.1

Revision e402ec24 - 2013-03-27 12:05 - Benno Weinzierl

[BUGFIX] Exception thrown in TypeHandling (follow up)

2015-08-04 2/8



When using isCollectionType() on an string, a warning is thrown.
The change id Iae59221cbd72677e6c18ad0a383792a798447253 introduced this.

Change-Id: Idb1a18fddae425fe03c4c1102c22133d716a6b65
Resolves: #45876
Releases: master, 2.0, 1.1

History
#1 - 2013-02-27 08:30 - Mattias Nilsson
- Tracker changed from Task to Bug
- Project changed from Base Distribution to TYPO3.Neos

#2 - 2013-02-27 14:58 - Mattias Nilsson
- File Screen_Shot_2013-02-27_at_2.57.58_PM.png added

The same error occurs when entering the Site Management Module. Url: neos/administration/sites/edit?moduleArguments[site][__identity]=indentitykey

#1: Warning: Unknown class passed as parameter in
/Applications/MAMP/htdocs/phoenix.dev/Base/Packages/Framework/TYPO3.Flow/Classes/TYPO3/Flow/Utility/TypeHandling.php line 118 (More
information)

#3 - 2013-03-02 07:49 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#4 - 2013-03-02 16:51 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#5 - 2013-03-03 17:23 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#6 - 2013-03-03 17:27 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#7 - 2013-03-06 16:27 - Benno Weinzierl

The current patchset fails in my installation (LAMP) because the following Type is not recognized as Collection:
Doctrine\ORM\PersistentCollection
IMHO is_subclass_of is not enough, it should also be checked for interfaces

#8 - 2013-03-07 15:19 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#9 - 2013-03-07 16:44 - Karsten Dambekalns

Benno Weinzierl wrote:

The current patchset fails in my installation (LAMP) because the following Type is not recognized as Collection:
Doctrine\ORM\PersistentCollection

IMHO is_subclass_of is not enough, it should also be checked for interfaces

Not needed after 5.3.7:
php -a
Interactive shell

php > var_dump(is_subclass_of('ArrayObject', 'ArrayAccess'));
bool(true)

The question is, when can we finally raise the minimum required PHP version to something sane?

#10 - 2013-03-07 16:46 - Karsten Dambekalns
- Status changed from New to Needs Feedback
- Assigned To set to Karsten Dambekalns

What PHP version are you running?

#11 - 2013-03-07 17:03 - Benno Weinzierl

Karsten Dambekalns wrote:

What PHP version are you running?

Jup! I am running 5.3.6...

#12 - 2013-03-07 17:40 - Karsten Dambekalns
- Project changed from TYPO3.Neos to TYPO3.Flow

#13 - 2013-03-07 17:41 - Karsten Dambekalns
- Subject changed from Exception when adding new content to Exception in TypeHandling with PHP < 5.3.7
- Category set to Utility
- PHP Version set to 5.3
- Has patch set to No
- Affected Flow version set to (any)

#14 - 2013-03-07 17:41 - Karsten Dambekalns
- Status changed from Needs Feedback to Under Review

#15 - 2013-03-08 08:34 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#16 - 2013-03-08 08:43 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18556

#17 - 2013-03-09 11:18 - Ottmar Biebersdorf

Karsten Dambekalns wrote:

The question is, when can we finally raise the minimum required PHP version to something sane?

I hope not as long as many production servers are using the current Debian (Squeeze) which uses PHP 5.3.3 at the moment. It would exclude many
production servers from beeing able to run Flow or Neos. So please wait a little longer. Thanks.

#18 - 2013-03-13 12:37 - Mattias Nilsson
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:57a78d3b789f24393f66a996faa62f28b469fefe.

#19 - 2013-03-14 01:18 - Benno Weinzierl

not fixed in my installation. Get Error:

#1: Warning: class_implements() [<a href='function.class-implements'>function.class-implements</a>]: Class string does not exist and could not be
loaded in .../Packages/Framework/TYPO3.Flow/Classes/TYPO3/Flow/Utility/TypeHandling.php line 128

Should look like this:

    static public function isCollectionType($type) {
        if (in_array($type, self::$collectionTypes, TRUE)) {
            return TRUE;
        }
        if (class_exists($type) === TRUE) {
            foreach (self::$collectionTypes as $collectionType) {
                if (is_subclass_of($type, $collectionType) === TRUE) {
                    return TRUE;
                }
            }

                // is_subclasss_of does not check for interfaces in PHP < 5.3.7
            if (version_compare(PHP_VERSION, '5.3.7', '<') === TRUE) {
                foreach (self::$collectionTypes as $collectionType) {
                    if (in_array($collectionType, class_implements($type)) === TRUE) {
                        return TRUE;
                    }
                }
            }
        }

        return FALSE;
    }

#20 - 2013-03-14 11:49 - Adrian Föder
- Status changed from Resolved to Under Review

reopened on behalf of Benno

#21 - 2013-03-14 12:19 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18900

#22 - 2013-03-14 15:00 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/18900

#23 - 2013-03-15 21:37 - Benno Weinzierl
- Status changed from Under Review to Resolved

Applied in changeset commit:5772372b5dcb5e3c7b1a24443a8db12a76bd0766.

#24 - 2013-03-19 17:37 - Gerrit Code Review
- Status changed from Resolved to Under Review
Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/19055

#25 - 2013-03-19 17:37 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/19056

#26 - 2013-03-19 17:41 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19057

#27 - 2013-03-19 17:41 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19058

#28 - 2013-03-19 18:37 - Benno Weinzierl
- Status changed from Under Review to Resolved

Applied in changeset commit:2a8841d3a8ac1e940fce964d1f9e4c5457b054db.

#29 - 2013-03-20 10:00 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19058

#30 - 2013-03-20 10:00 - Gerrit Code Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at https://review.typo3.org/19057

#31 - 2013-03-27 12:08 - Gerrit Code Review

Patch set 1 for branch composer has been pushed to the review server.
It is available at https://review.typo3.org/19349

#32 - 2013-03-27 12:08 - Gerrit Code Review

Patch set 1 for branch composer has been pushed to the review server.
It is available at https://review.typo3.org/19352
#33 - 2013-03-27 13:37 - Benno Weinzierl
- Status changed from Under Review to Resolved

Applied in changeset commit:e402ec242bbf1d08dc9c5146f608a4ee71540128.

Files
Screen_Shot_2013-02-27_at_8.24.52_AM.png 111.4 kB 2013-02-27 Mattias Nilsson
Screen_Shot_2013-02-27_at_2.57.58_PM.png 325.3 kB 2013-02-27 Mattias Nilsson
